#include "PyEMDataWrap.h"
#include "PyEMData.h"
#include "PyEuler.h"
#include "PyVect.h"
#include "PyPickle.h"
#include <boost/python.hpp>
#include <boost/python/to_python_converter.hpp>

namespace python = boost::python;

BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setTAlign, setTAlign, 2, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setRAlign, setRAlign, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_zero, zero, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlign, py_RTFAlign, 0, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignBest, py_RTFAlignBest, 0, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_refineAlign, refineAlign, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignRadon, py_RTFAlignRadon, 1, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTAlignRadon, py_RTAlignRadon, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignSlow, py_RTFAlignSlow, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignSlowest, py_RTFAlignSlowest, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_makeRFP, py_makeRFP, 0, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_unwrap, py_unwrap, 0, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_littleBigDot, py_littleBigDot, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotAlignCH, rotAlignCH, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_transAlign3d, transAlign3d, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcCCF, py_calcCCF, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcFLCF, py_calcFLCF, 2, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcCCFX, py_calcCCFX, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcMCF, py_calcMCF, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_transAlign, transAlign3d, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotateAndTranslate, rotateAndTranslate, 0, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotateAndTranslateFast, rotateAndTranslateFast, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_fastTranslate, fastTranslate, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_cmCenter, cmCenter, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_applyMask, applyMask, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_autoMask, autoMask, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_applyRadFn, py_applyRadFn, 4, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_normalizeTo, py_normalizeTo, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_edgeNormalize, edgeNormalize, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_xNormalize, xNormalize, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_leastSquareNormalizeTo, py_leastSquareNormalizeTo, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_maskNormalize, maskNormalize, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dotRT, dotRT, 4, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dot, dot, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_lcmp, py_lcmp, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_realFilter, realFilter, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverage, py_makeAverage, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverageCTFCWauto, py_makeAverageCTFCWauto, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverageCTFCW, py_makeAverageCTFCW, 2, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_mult, mult, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_commonLines, commonLines, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_project3d, py_project3d, 4, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_commonLinesR, commonLinesR, 2, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_fftSlice, py_fftSlice, 3, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setup4Slice, setup4Slice, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_insertSlice, insertSlice, 4, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_doneSlice, doneSlice, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_doneSliceWF, doneSliceWF, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_cutSlice, cutSlice, 2, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_uncutSlice, uncutSlice, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_ctfMap, ctfMap, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dist, dist, 1, 2);

void export_EMData3(python::class_<EMData>& EMData_class, python::class_<PyEMData, python::bases<EMData> >& PyEMData_class)
{
    EMData_class.def("vFlip", &EMData::vFlip, 
		     "vFlip()\n  flips image vertically");
    EMData_class.def("hFlip", &EMData::hFlip, 
		     "hFlip()\n  flips image horizontally");
    EMData_class.def("normalize", &EMData::normalize, 
		     "normalize()\n  mean -> 0, std dev -> 1");
    EMData_class.def("normalizeTo", &PyEMData::py_normalizeTo, 
		     EMData_normalizeTo("tuple normalizeTo(EMData noisy,int keepzero=0,int invert=0)\n  This will multiply 'this' by a constant so. it is scaled to the signal in 'to'keepzero will exclude zero values, and keep them at zero in the result"));
    EMData_class.def("normalizeMax", &EMData::normalizeMax, 
		     "normalizeMax()\n  mean -> 0, std dev -> 1");
    EMData_class.def("edgeNormalize", &EMData::edgeNormalize, 
		     EMData_edgeNormalize("edgeNormalize(int cir=0)\n  normalizes so mean -> value at edge of image, if cir=1, uses 2 pixel circular border"));
    EMData_class.def("xNormalize", &EMData::xNormalize, 
		     EMData_xNormalize("xNormalize(int mode=0)\n  normalizes each row in the image individually"));
    EMData_class.def("addMaskShell", &EMData::addMaskShell, 
		     "addMaskShell(int shells)\n  Will add additional shells/rings to an existing 1/0 mask image");
    EMData_class.def("leastSquareNormalizeTo", &PyEMData::py_leastSquareNormalizeTo, 
		     EMData_leastSquareNormalizeTo("tuple leastSquareNormalizeTo(EMData to, float low_thresh=FLT_MIN, float high_thresh=FLT_MAX)"));
    EMData_class.def("maskNormalize", &EMData::maskNormalize, 
		     EMData_maskNormalize("maskNormalize(EMData mask,int sigmatoo=1)\n  Uses a 1/0 mask defining a region to use for the zero-normalization, if sigma is 0, std-dev not modified"));
    EMData_class.def("invert", &EMData::invert, 
		     "invert()\n  multiply by -1");
    EMData_class.def("calcRadDist", (void (PyEMData::*)(int, float, float, PyList))&PyEMData::py_calcRadDist, 
		     "calcRadDist(int n,float x0,float dx, list y)");
    EMData_class.def("calcRadDist", (void (PyEMData::*)(int, float, float, PyList, float, float))&PyEMData::py_calcRadDist, 
		     "calcRadDist(int n,float x0,float dx, list y)");

    EMData_class.def("calcAzDist", &PyEMData::py_calcAzDist, 
		     "calcAzDist(int n,float a0,float da, list data,float rmin,float rmax)");
    EMData_class.def("radialAverage", &EMData::radialAverage, 
		     "radialAverage()\n  makes image circularly symmetric");
    EMData_class.def("radialSubtract", &EMData::radialSubtract, 
		     "radialSubtract()\n  subtracts circularly symmetric part of image");
    EMData_class.def("toCorner", &EMData::toCorner,
		     "toCorner \n Translates a centered image to the corner");

    EMData_class.def("dotRT", &EMData::dotRT,
		     EMData_dotRT("float dot(EMData data,float dx,float dy,float da)\n  dot product of 2 images with 'this' rotated and translated (same size !). MUCH faster than RotateAndTranslate() followed by dot()."));
    EMData_class.def("dot", &EMData::dot,
		     EMData_dot("float dot(EMData data,int evenonly=0)\n  dot product of 2 images (same size !)"));
    EMData_class.def("lcmp", &PyEMData::py_lcmp,
		     EMData_lcmp("tuple lcmp(EMData noisy,int keepzero=0,int invert=0)\n  linear comparison of 2 data sets (smaller better)"));
    EMData_class.def("pcmp"  , &EMData::pcmp,
		     "float pcmp(EMData data, XYData snr=None) \n  amplitude weighted mean phase error, 'data' should be less noisy than 'this' pcmp");
    EMData_class.def("fscmp", &EMData::fscmp, 
		     " float fscmp(EMData with)\n  returns a quality factor based on FSC between images larger numbers indicate a better match");
    
    EMData_class.def("dCenter", &EMData::dCenter, 
		     "float dCenter()\n  This will find the density value at the peak of the image histogram, sort of like the mode of the density");
    EMData_class.def("sigDiff", &EMData::sigDiff, 
		     "float sigDiff()\n  Calculates sigma above and below the mean and returns the difference between them");
    EMData_class.def("realFilter", &EMData::realFilter, 
		     EMData_realFilter("realFilter(int type, float val1=0,float val2=0, float val3=0)\n  a variety of real-space filters"));
    EMData_class.def("filter", &EMData::filter, 
		     "filter(float highpass,float lowpass,int type)\n  fourier filters an image, real or imaginary");
    PyEMData_class.def("matchFilter", &PyEMData::py_matchFilter, python::return_value_policy<python::manage_new_object>(),
		       ("this.matchFilter(EMData to)\nfilters 'this' to match the radial power spectrum of 'to'"));
    EMData_class.def("makeAverage", &PyEMData::py_makeAverage,
		     EMData_makeAverage("makeAverage(list in,EMData sigma=None, int ignore0=0)\n  averages the images in the list, result in 'this' optionally makes a sigma image as well"));
    EMData_class.def("makeAverageIter", &PyEMData::py_makeAverageIter, 
		     "makeAverageIter(list in)");
    EMData_class.def("makeAverageWT", &PyEMData::py_makeAverageWT, 
		     "makeAverageWT(list in,EMData curves,XYData sf)\n  averages the images in the list with SNR weightingbut no CTF correction");
    EMData_class.def("makeAverageCTFC", &PyEMData::py_makeAverageCTFC, 
		     "makeAverageCTFC(list in,float filtr)\n  averages the images in the list with CTF correction filtr is in angstroms,");
    EMData_class.def("makeAverageCTFCWauto", &PyEMData::py_makeAverageCTFCWauto, 
		     EMData_makeAverageCTFCWauto("makeAverageCTFCWauto(list in, string outfile=None)\n  This does CTF correction with a Wiener filter where the filter is estimated directly from the data"));
#ifndef WIN32
	EMData_class.def("makeAverageCTFCW", &PyEMData::py_makeAverageCTFCW, 
		     EMData_makeAverageCTFCW("makeAverageCTFCW(list in, XYData sf, list SNR=None)\n  averages the images in the list with CTF correction"));
#endif
	EMData_class.def("makeMedian", &PyEMData::py_makeMedian, 
		     "makeMedian(list in)\n  Median of the images in the list, result in 'this'");

    EMData_class.def("add", (void (EMData::*)(EMData*))&EMData::add, 
		     "add(EMData in)\n  adds 'in' to 'this'");

    EMData_class.def("add", (void (EMData::*)(float))&EMData::add, 
		     "add(float d)\n  add const number to each element");

    EMData_class.def("addIncoherent", &EMData::addIncoherent, 
		     "addIncoherent(EMData in)\n  adds 'in' to 'this'");
    EMData_class.def("mult", &EMData::mult, 
		     EMData_mult("mult(EMData in,int recip=0)\n  multiplies 'in' by 'this', if recip, then divide"));
    EMData_class.def("multConst", &EMData::multConst, 
		     "multConst(float)\n  multiply by constant");
    EMData_class.def("addConst", &EMData::addConst, 
		     "addConst(float)\n add a constant");
    EMData_class.def("meanShrink", &EMData::meanShrink, 
		     " meanShrink(int i)\n  reduces the size of the image by a factor of i, using the average value of the pixels in a block");
    EMData_class.def("medianShrink", &EMData::medianShrink, 
		     "medianShrink(int i)\n  reduces the size of the image by a factor of i using a local median filter");
    EMData_class.def("commonLines", &EMData::commonLines, 
		     EMData_commonLines("commonLines(EMData d1,EMData d2,int mode=0,int steps=180,int horiz=0) \n  finds common lines between 2 complex images. mode 0 is a summed dot-product mode 1 is weighted phase residualsteps is 1/2 the resolution of the )map"));
    EMData_class.def("commonLinesR", &EMData::commonLinesR, 
		     EMData_commonLinesR("commonLinesR(EMData data1,EMData data2,int steps=180,int horiz=0)"));
    PyEMData_class.def("project3d", &PyEMData::py_project3d,		     
		       EMData_py_project3d("EMData project3d(float alt,float az, float phi, int mode, float thr=1.0) \n  makes a 3d projection of a volume, mode=-1 does real space projection, 1-5 use fftslice for fourier projection")
		       [python::return_value_policy<python::manage_new_object>()]);
    
}
