#include "PyEMDataWrap.h"
#include "PyEMData.h"
#include "PyEuler.h"
#include "PyVect.h"
#include "PyPickle.h"
#include <boost/python.hpp>
#include <boost/python/to_python_converter.hpp>

namespace python = boost::python;

BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setTAlign, setTAlign, 2, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setRAlign, setRAlign, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_zero, zero, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlign, py_RTFAlign, 0, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignBest, py_RTFAlignBest, 0, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_refineAlign, refineAlign, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignRadon, py_RTFAlignRadon, 1, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTAlignRadon, py_RTAlignRadon, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignSlow, py_RTFAlignSlow, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_RTFAlignSlowest, py_RTFAlignSlowest, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_makeRFP, py_makeRFP, 0, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_unwrap, py_unwrap, 0, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_littleBigDot, py_littleBigDot, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotAlignCH, rotAlignCH, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_transAlign3d, transAlign3d, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcCCF, py_calcCCF, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcFLCF, py_calcFLCF, 2, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcCCFX, py_calcCCFX, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_calcMCF, py_calcMCF, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_transAlign, transAlign3d, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotateAndTranslate, rotateAndTranslate, 0, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_rotateAndTranslateFast, rotateAndTranslateFast, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_fastTranslate, fastTranslate, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_cmCenter, cmCenter, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_applyMask, applyMask, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_autoMask, autoMask, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_applyRadFn, py_applyRadFn, 4, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_normalizeTo, py_normalizeTo, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_edgeNormalize, edgeNormalize, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_xNormalize, xNormalize, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_leastSquareNormalizeTo, py_leastSquareNormalizeTo, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_maskNormalize, maskNormalize, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dotRT, dotRT, 4, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dot, dot, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_lcmp, py_lcmp, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_realFilter, realFilter, 1, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverage, py_makeAverage, 1, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverageCTFCWauto, py_makeAverageCTFCWauto, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_makeAverageCTFCW, py_makeAverageCTFCW, 2, 3);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_mult, mult, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_commonLines, commonLines, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_project3d, py_project3d, 4, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_commonLinesR, commonLinesR, 2, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_py_fftSlice, py_fftSlice, 3, 4);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_setup4Slice, setup4Slice, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_insertSlice, insertSlice, 4, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_doneSlice, doneSlice, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_doneSliceWF, doneSliceWF, 0, 1);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_cutSlice, cutSlice, 2, 6);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_uncutSlice, uncutSlice, 2, 5);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_ctfMap, ctfMap, 1, 2);
BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(EMData_dist, dist, 1, 2);

void export_EMData4(python::class_<EMData>& EMData_class, python::class_<PyEMData, python::bases<EMData> >& PyEMData_class)
{
    PyEMData_class.def("fftSlice", &PyEMData::py_fftSlice, 
		       EMData_py_fftSlice("EMData fftSlice(float alt,float az,float phi,int mode=5)\n  takes a slice from a 3d complex image for generating projections.")
		       [python::return_value_policy<python::manage_new_object>()]);
    
    EMData_class.def("setup4Slice", &EMData::setup4Slice, 
		     EMData_setup4Slice("setup4Slice(int redo=1)"));
    
    EMData_class.def("interpFT3d", &PyEMData::py_interpFT3d, 
		     "interpFT3d(float x,float y,float z, list ret,int mode)");
    
    EMData_class.def("setup4IS", &EMData::setup4IS, 
		     " setup4IS(int size)");
    EMData_class.def("normSlice", &PyEMData::py_normSlice, 
		     "tuple normSlice(EMData slice,float alt,float az,float phi)\n  try to make sure the slice is normalized properly");
    EMData_class.def("insertSlice", &EMData::insertSlice, 
		     EMData_insertSlice("insertSlice(EMData slice,  float alt,float az,float phi,int mode=5,float weight=1.0) \n  this inserts a complex slice into an image that has been setup4IS()"));
    EMData_class.def("insertSliceWF", &EMData::insertSliceWF, 
		     "insertSliceWF(EMData slice,  float alt,float az,float phi,int mode,list SNR,float padratio)\n  this inserts a complex slice into an image that has been setup4IS()");
    EMData_class.def("doneSlice", &EMData::doneSlice, 
		     EMData_doneSlice("doneSlice(int log=0)\n   once all of the slices have been added with insertSlice(), this routine does a normalization and returns a real 3d volume"));
    EMData_class.def("doneSliceWF", &EMData::doneSliceWF, 
		     EMData_doneSliceWF("doneSliceWF(int log=0)\n  It should only be used in conjunction with insertSliceWF"));
    EMData_class.def("insertSlice3DReal", &EMData::insertSlice3DReal, 
		     "insertSlice3DReal(EMData slice,float weight)");

    EMData_class.def("cutSlice", (void (EMData::*)(EMData*, float, Euler*, int, float, float))&EMData::cutSlice,
		     EMData_cutSlice("void cutSlice(EMData *map,float z,Euler *ort=NULL,int interp=1,float x=0,float y=0)\n  this will cut a slice out of a real 3D map"));

    EMData_class.def("uncutSlice", (void (EMData::*)(EMData*, float, Euler*, float, float))&EMData::uncutSlice,
		     EMData_uncutSlice("void uncutSlice(EMData *map,float z, Euler sort=NULL,float x=0,float y=0)\n  Opposite of cutSlice(). It will take a slice and insert the data into a real 3D map. It does not interpolate, it uses the nearest neighbor."));


    EMData_class.def("fsc", &PyEMData::py_fsc, "list fsc(EMData with); \n  returns the Fourier ring/shell correlation coef as an array with ysize/2 elements (corners not calculated).");
    
    EMData_class.def("setSFFile", &PyEMData::py_setSFFile, "void setSFFile(const char* filename)");
	
    EMData_class.def("ctfCurve", &PyEMData::py_ctfCurve, "list ctfCurve(int type=0, XYData sf=NULL)\n  Calculates a CTF curve. optional structure factor data for true SNR calc.");
    
    EMData_class.def("ctfMap", &EMData::ctfMap, 
		     EMData_ctfMap("ctfMap(int type, XYData sf=None)"));
    EMData_class.def("getCTF", &PyEMData::py_getCTF,
		     "list getCTF() \n  Returns the CTF parameters in a list.");

    EMData_class.def("setCTF", &PyEMData::py_setCTF, 
		     "setCTF(list new_ctf) \n  Sets CTF parameters with new values from a list. \n\nsetCTFF(string s) \n  Sets CTF parameters with new values from a string.");

    EMData_class.def("setCTFF", &EMData::setCTFF, 
		     "setCTF(list new_ctf) \n  Sets CTF parameters with new values from a list. \n\nsetCTFF(string s) \n  Sets CTF parameters with new values from a string.");
    
    EMData_class.def("clearCTF", &EMData::clearCTF, 
		     "clearCTF() \n  Clear CTF parameters.");
    
    EMData_class.def("CTFCmp", &EMData::CTFCmp, 
		     "int CTFCmp(EMData with)\n  used to detect if 2 images have the same CTF parameters");

    EMData_class.def("subNoise", &EMData::subNoise, 
		     "subNoise() \n  Subtract average noise from intensity. Negative results allowed.");

    PyEMData_class.def("iftSlice", &PyEMData::py_iftSlice,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData iftSlice()\n  This does an IFT of a volume reconstructed from slices. Includes a real-space correction for the linear interpolation in Fourier space");

    EMData_class.def("valueAt", (float (EMData::*)(int, int, int))&EMData::valueAt, 
		     "float valueAt(int x, int y) \n  Return data at a 2D position. \n\nfloat valueAt(int x, int y, int z) \n  Return data at a 3D position.");
    
    EMData_class.def("valueAt", (float (EMData::*)(int, int))&EMData::valueAt, 
		     "float valueAt(int x, int y) \n  Return a data value at a 2D position. It has no locking. \n\nfloat valueAt(int x, int y, int z) \n  Return a data value at a 3D position. It has no locking.");

    EMData_class.def("valueAtInterp", (float (EMData::*)(float, float))&EMData::valueAtInterp,
		     "float valueAtInterp(float x, float y) \n Returns a data value at a 2D position.");
    
    EMData_class.def("valueAtInterp", (float (EMData::*)(float, float, float))&EMData::valueAtInterp,
		     "float valueAtInterp(float x, float y, float z) \n Returns a data value at a 3D position.");
        
    EMData_class.def("valueAtSafe", (float (EMData::*)(int, int, int))&EMData::valueAtSafe, 
		     "float valueAtSafe(int x, int y) \n  Return a data value at a 2D position. It has no locking. \n\nfloat valueAtSafe(int x, int y, int z) \n  Return a data value at a 3D position. It has no locking.");
    
    EMData_class.def("valueAtSafe", (float (EMData::*)(int, int))&EMData::valueAtSafe, 
		     "float valueAtSafe(int x, int y) \n  Return a data value at a 2D position. It has no locking. \n\nfloat valueAtSafe(int x, int y, int z) \n  Return a data value at a 3D position. It has no locking.");
    
    EMData_class.def("setValueAt", &EMData::setValueAt, 
		     "setValueAt(int x, int y, int z, float v)\n it does not set the changed flag");
    PyEMData_class.def("row", &PyEMData::py_row,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData row(int n)\n  extract vector from matrix");
    PyEMData_class.def("col", &PyEMData::py_col,
		       python::return_value_policy<python::manage_new_object>(),
		       "EMData col(int n)\n  extract vector from matrix");
    EMData_class.def("setRow", &EMData::setRow, 
		     "setRow(EMData d,int n)\n  insert vector into matrix");
    EMData_class.def("setCol", &EMData::setCol, 
		     "setCol(EMData d,int n)\n  insert vector into matrix");
    PyEMData_class.def("mxMult", &PyEMData::py_mxMult,
		       python::return_value_policy<python::manage_new_object>(),
		       " EMData mxMult(EMData second)");
    EMData_class.def("dist", &EMData::dist, 
		     EMData_dist("float dist(EMData second, int n=0)"));

    EMData_class.def_pickle(EMData_pickle_suite());

    PyEMData_class.def(python::self += float());
    PyEMData_class.def(python::self -= float());
    PyEMData_class.def(python::self *= float());
    PyEMData_class.def(python::self /= float());

    PyEMData_class.def(python::self += python::self);
    PyEMData_class.def(python::self -= python::self);
    PyEMData_class.def(python::self *= python::self);
    PyEMData_class.def(python::self /= python::self);
    
    PyEMData_class.def(python::self + float());
    PyEMData_class.def(python::self - float());
    PyEMData_class.def(python::self * float());
    PyEMData_class.def(python::self / float());

    PyEMData_class.def(float() + python::self);
    PyEMData_class.def(float() - python::self);
    PyEMData_class.def(float() * python::self);
    PyEMData_class.def(float() / python::self);

    PyEMData_class.def(python::self + python::self);
    PyEMData_class.def(python::self - python::self);
    PyEMData_class.def(python::self * python::self);
    PyEMData_class.def(python::self / python::self);
}
