/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename slots use Qt Designer which will
** update this file, preserving your code. Create an init() slot in place of
** a constructor, and a destroy() slot in place of a destructor.
*****************************************************************************/

#ifdef WIN32
	#include <qmessagebox.h>
#endif

void Control::helpIndex()
{

}

void Control::helpContents()
{

}

void Control::helpAbout()
{

}


void Control::doCopyPlus()
{
Euler ort(alt->Value()*PI/180.0,0,az->Value()*PI/180.0);
layersegd->cutSlice(seg,layer->value()-1,&ort,0);
layersegd->unum2=1;
layerview->setSegData(layersegd);
}

void Control::doUndo()
{
refreshlayer();
if (!undoseg) return;
EMData *tmp = undoseg;
undoseg=seg;
seg=tmp;
refreshlayer();
}

void Control::doUpdate()
{
if (chimera<1 || !chimerain || !chimeraout) return;

savemdata(QString("/tmp/seg"),0);

printf("%s\n",chimerado("'test'"));
printf("%s\n",chimerado("g=VolumeData.open_file_type('/tmp/seg0.mrc','mrc')"));
printf("%s\n",chimerado("d.add_data_sets([g])"));

}

void Control::layerSel(int i)
{
refreshlayer();
}

void Control::segSel(int i)
{
layerview->setSegDisp(i);
}

void Control::setAlt(float f)
{
refreshlayer();
}

void Control::setAz(float)
{
refreshlayer();
}

void Control::togChimera(bool yn)
{
#ifndef WIN32
   if (chimera==-1) {
		int pr=fork();
		if (pr==0) system("chimera --start 'Volume Viewer' --start 'EMAN Link'");
    	else {
			char s[256];
			sprintf(s,"%s/tofifo",DFdir());
			chimeraout=fopen(s,"wb");
			sprintf(s,"%s/fromfifo",DFdir());
			chimerain=fopen(s,"rb");
		}
	}
    chimera=yn;
#else
	QMessageBox::warning(this,"Qsegment","Visualization using Chimera is not supported on Windows platform yet. "
		"We will provide this functionality in future version\n");
#endif
}


void Control::setDrawRad()
{
layerview->setDrawRad(drawrad->text().toInt());
}

void Control::doNewSeg()
{
QString s("Segment ");
s=s+QString::number(seglist->count());

seglist->insertItem(s,seglist->count());
showseg->setMaxValue(seglist->count()-1);

}

void Control::renameSeg()
{
seglist->changeItem(segname->text(),seglist->currentItem());

}

void Control::loadModel()
{
QString s( QFileDialog::getOpenFileName() );
if ( s.isNull() ) return;

if (!data) data=new EMData;
data->readImage((const char *)s,-1);

if (!seg) { seg=data->copyHead(); seg->zero(); }
if (data->xSize()!=seg->xSize() || data->ySize()!=seg->ySize() || data->zSize()!=seg->zSize()) {
	seg->setSize(data->xSize(),data->ySize(),data->zSize());
	seg->zero();
}
dim=data->xSize();
if (data->ySize()>dim) dim=data->ySize();
if (data->zSize()>dim) dim=data->zSize();

layer->setMinValue(-dim*17/20);
layer->setMaxValue(dim*17/20);

layerview->setMin(data->Min());
layerview->setMax(data->Max());

refreshlayer();
}

void Control::doV5D() {
char s[1024];
int i;

data->writeMRC("qseg1.mrc");
seg->writeMRC("qseg2.mrc");
savemdata(QString("tmpmsk."),0);
sprintf(s,"mrc2v5d ");
for (i=0; i<=seg->Max(); i++) {
	sprintf(s+strlen(s),"tmpmsk.%d.mrc ",i);
}
sprintf(s+strlen(s),"qseg.v5d");
system(s);
//system("mrc2v5d qseg1.mrc qseg2.mrc qseg.v5d");

//sprintf(s,"vis5d -box 1 1 1 -path / -script %s/doc/qsegscript.tcl qseg.v5d",EMDIR);
sprintf(s,"vis5d -box 1 1 1 -path / -mbs 384 qseg.v5d");

system(s); 
}

void Control::loadSegmap()
{
QString s( QFileDialog::getOpenFileName() );
if ( s.isNull() ) return;

if (!seg) seg=new EMData;
seg->readMRC((const char *)s);
if (data->xSize()!=seg->xSize() || data->ySize()!=seg->ySize() || data->zSize()!=seg->zSize()) {
	seg->setSize(data->xSize(),data->ySize(),data->zSize());
	seg->zero();
}

mrcH *hed=seg->getMRCHed();
seglist->clear();
seglist->insertItem(QString("Clear"));
for (int i=1; i<=seg->Max(); i++) {
	if (i<=10 && strncmp(hed->labels[i-1],"EMAN",4)!=0 && strlen(hed->labels[i-1])>1) {
		hed->labels[i-1][30]=0;
		seglist->insertItem(QString(hed->labels[i-1]));
	}
	else seglist->insertItem(QString("Segment ")+QString::number(seglist->count()));
}

layersegd->unum2=0;
refreshlayer();
}

void Control::dosaveMaskedImage()
{
QString s=OneLiner::getOneLine("Enter filename prefix", "masked.");
int i;
if (s.length()<1) return;

savemdata(s,0);

}

void Control::saveMasks()
{
QString s=OneLiner::getOneLine("Enter filename prefix", "mask.");
int i;
if (s.length()<1) return;

for (i=0; i<=seg->Max(); i++) {
	EMData *cp=seg->copy(0,0);
	cp->realFilter(14,(float)i,(float)i);
	cp->writeMRC(s+QString::number(i)+QString(".mrc"));
	delete cp;
}

}

void Control::saveSegmap()
{
QString s( QFileDialog::getSaveFileName(0,"*.mrc") );
if ( s.isNull() ) return;

if (!seg->getMRCHed()) seg->writeMRC("/dev/null");
mrcH *hed=seg->getMRCHed();

for (int i=0; i<10; i++) {
	sprintf(hed->labels[i],"%0.79s",(const char *)seglist->text(i+1));
}

seg->writeMRC((const char *)s);
}

void Control::doexit()
{
    if (chimera!=-1) chimerado("bye");
exit(0);
}


void Control::init()
{
data=seg=undoseg=NULL;
layerview=new SliceImage(NULL,"lv");
layerview->show();
connect(layerview,SIGNAL(doubleclicked(int,int,int)),this,SLOT(spotflood(int,int,int)));

alt->setMin(-90.0);
alt->setMax(0.0);
az->setMin(0);
az->setMax(360.0);

layerd=layersegd=NULL;
chimera=-1;
chimeraout=chimerain=NULL;
}


void Control::drawSeg( int i)
{
layerview->setDrawSeg(i);
}


void Control::doCopyMinus()
{
Euler ort(alt->Value()*PI/180.0,0,az->Value()*PI/180.0);
layersegd->cutSlice(seg,layer->value()+1,&ort,0);
layersegd->unum2=1;
layerview->setSegData(layersegd);

}

void Control::spotflood(int x1, int y1, int segn) {
layersegd->uncutSlice(seg,(float)layersegd->unum,layersegd->getEuler());
layersegd->unum2=0;
float *mx = layersegd->getEuler()->mat();

if (undoseg) delete undoseg;
undoseg=seg->copy(0,0);

// Find the 3D coords of the double click position
float x2=x1-layersegd->xSize()/2;
float y2=y1-layersegd->ySize()/2;
int xx=round(x2*mx[0]+y2*mx[1]+layer->value()*mx[2]+seg->xSize()/2);
int yy=round(x2*mx[3]+y2*mx[4]+layer->value()*mx[5]+seg->ySize()/2);
int zz=round(x2*mx[6]+y2*mx[7]+layer->value()*mx[8]+seg->zSize()/2);

printf("Spotflood %d,%d,%d   %d\n",xx,yy,zz,segn);

seg->setValueAt(xx,yy,zz,-segn);

int iter=atoi((const char *)filliter->text());
float thr=fillthr->text().toFloat();

int i,ii,jj,kk,x,y,z;
for (i=1; i<iter; i++) {
	for (z=zz-i; z<=zz+i; z++) {
		for (y=yy-i; y<=yy+i; y++) {
			for (x=xx-i; x<=xx+i; x++) {
				if (x==xx-i+1 && y!=yy-i && y!=yy+i && z!=zz-i && z!=zz+i) x=xx+i;	// this makes a hollow cube
				if (x<1||y<1||z<1||x>seg->xSize()-2||y>seg->ySize()-2||z>seg->zSize()-2) continue;
				
				if (data->valueAt(x,y,z)<thr || (seg->valueAt(x,y,z)!=0 && seg->valueAt(x,y,z)!=segn)) continue;
				
				int g=0;
				for (kk=z-1; kk<=z+1; kk++) {
					for (jj=y-1; jj<=y+1; jj++) {
						for (ii=x-1; ii<=x+1; ii++) {
							if (seg->valueAt(ii,jj,kk)==-segn) g=1;
						}
					}
				}
				if (g) seg->setValueAt(x,y,z,-segn);
			}
		}
	}
}
seg->realFilter(4);
layersegd->unum2=0;
refreshlayer();
}

void Control::refreshlayer() {
if (!data || !seg) return;

if (!layerd || layerd->xSize()!=dim) {
	if (layerd) delete layerd;
	if (layersegd) delete layersegd;
	layerd=new EMData;
	layerd->setSize(dim,dim,1);
	layersegd=new EMData;
	layersegd->setSize(dim,dim,1);
}
else {
	if (layersegd->unum2) {
//		printf("%f,%f   %d %d",layersegd->alt(),layersegd->phi(),layersegd->unum,layersegd->unum2);
		if (undoseg) delete undoseg;
		undoseg=seg->copy(0,0);
		layersegd->uncutSlice(seg,layersegd->unum,layersegd->getEuler());
	}
}
Euler ort(alt->Value()*PI/180.0,0,az->Value()*PI/180.0);
layerd->cutSlice(data,layer->value(),&ort,1);
layersegd->cutSlice(seg,layer->value(),&ort,0);

layersegd->setRAlign(&ort);
layersegd->unum=layer->value();
layersegd->unum2=0;
layerview->setData(layerd);
layerview->setSegData(layersegd);

}

void Control::savemdata(QString file,int clip) {
if (!seg || !data) return;    

int i;
if (clip) error(ERR_EXIT,"CLIP NOT SUPPORTED");

for (i=0; i<=seg->Max(); i++) {
	EMData *cp=seg->copy(0,0);
	cp->realFilter(14,(float)i,(float)i);
	cp->mult(data);
	cp->writeMRC(file+QString::number(i)+QString(".mrc"));
	delete cp;
}

}

EMData* Control::getSeg() {
	if (!seg) {
		seg=data->copyHead();
		seg->zero();
	}
	return seg;
}

// Sends a 1-line command to chimera for evaluation
char *Control::chimerado(const char *command) {
static char *rbuf = (char *)malloc(128);
static int rbufm=128;

// send the command
fwrite(command,strlen(command),1,chimeraout);
if (command[strlen(command)-1]!='\n') fputc('\n',chimeraout);
fflush(chimeraout);
printf("send '%s'\n",command);

// read thru the first instance of !$@#
int pos=0;
while (fread(rbuf+pos,1,1,chimerain)==1) {
	pos++;
	if (pos>=rbufm-2) { rbuf=(char *)realloc(rbuf,rbufm*2); rbufm*=2; }
	if (pos>3 && strncmp(rbuf+pos-4,"!$@#",4)==0) { rbuf[pos-4]=0; break; }
}

return rbuf;
}


void Control::foldHunter()
{

}

void Control::helixHunter()
{

}

void Control::segment3d()
{

}
